
#include "mpi.h"
#include <stdio.h>
#include <sys/time.h>

const int N = 100 ;
const int NITER = 100000 ;

static int remId ;

#define STATIC_BUFFER_SIZE 262144

char recvBuf [STATIC_BUFFER_SIZE] ;
char sendBuf [STATIC_BUFFER_SIZE] ;

MPI_Request events [2] ;

int main(int argc, char** argv) {
  MPI_Init(&argc, &argv) ;

  int locId ;
  MPI_Comm_rank(MPI_COMM_WORLD, &locId) ;
  remId = 1 - locId ;

  clock() ;

  for(int iter = 0 ; iter < NITER ; iter++) {
    for(int parity = 0 ; parity < 2 ; parity++) {

      MPI_Isend(sendBuf, N * sizeof(int),
		MPI_CHAR, remId, 0, MPI_COMM_WORLD, events + 1) ;

      MPI_Irecv(recvBuf, N * sizeof(int), MPI_CHAR,
		remId, 0, MPI_COMM_WORLD, events) ;

      int eventId ;
      MPI_Status status ;

      for(int i = 0 ; i < 2 ; i++)
	MPI_Waitany(2, events, &eventId, &status) ;

    }
  }

  clock_t t = clock() ;
  if(locId == 0)
    printf("elapsed time = %f\n", (float) t / CLOCKS_PER_SEC) ;

  MPI_Finalize() ;
}


